// Easy.cpp : implementation file
//

#include "stdafx.h"
#include "Guess.h"
#include "Easy.h"

#include "Time.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEasy dialog


CEasy::CEasy(CWnd* pParent /*=NULL*/)
	: CDialog(CEasy::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEasy)
	m_nInsert = 0;
	//}}AFX_DATA_INIT
}


void CEasy::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEasy)
	DDX_Text(pDX, IDC_INSERT, m_nInsert);
	DDV_MinMaxInt(pDX, m_nInsert, 0, 9999);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEasy, CDialog)
	//{{AFX_MSG_MAP(CEasy)
	ON_BN_CLICKED(IDC_RESET, OnReset)
	ON_BN_CLICKED(IDC_CHECK, OnCheck)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEasy message handlers


void CEasy::OnOK() 
{
	SendMessage(WM_COMMAND, IDC_CHECK);
//	CDialog::OnOK();
}

void CEasy::OnCancel() 
{
//	CDialog::OnCancel();
}

void CEasy::OnReset() 
{
	SetDlgItemText(IDC_INSERT, "0");
	SetDlgItemText(IDC_ANSWER, "");

	MakeGoal();
}

void CEasy::OnCheck() 
{
	UpdateData();

	if(m_nInsert > 10000 || m_nInsert < 0)
		return;

	if ( CheckDiff(m_nInsert) == TRUE )
		EasyCompare(m_nGoal, m_nInsert);
	else
		AfxMessageBox("Please insert four different numbers!");	
}

BOOL CEasy::OnInitDialog() 
{
	CDialog::OnInitDialog();

	MakeGoal();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEasy::Split(int nSource, int *nDirect)
{
	nDirect[0] = nSource/1000;
	nDirect[1] = (nSource/100) % 10;
	nDirect[2] = (nSource%100) / 10;
	nDirect[3] = nSource%10;
}

int CEasy::Compare(int nGoal, int nInsert)
{
	int tGoal[4], tInsert[4];
	int tempA = 0, tempB = 0;
	int nAnswer;

	Split(nGoal, tGoal);
	Split(nInsert, tInsert);

	for ( int i = 0 ; i < 4 ; i++ )
		for ( int j = 0 ; j < 4 ; j++ )
			if ( tGoal[i] == tInsert[j] )
				if ( i == j )
					tempA++;
				else
					tempB++;

	nAnswer = 10*tempA + tempB;
	return nAnswer;
}

BOOL CEasy::CheckDiff(int nNumber)
{
	int temp[4];

	Split(nNumber, temp);

	for(int i = 0 ; i < 4 ; i++)
		for(int j = 0 ; j < 4 ; j++)
			if(i != j && temp[i] == temp[j])
					return FALSE;
	return TRUE;
}

void CEasy::MakeGoal()
{
	srand( (unsigned)time( NULL ) );

	m_nGoal = rand();

	while(!CheckDiff(m_nGoal))
		m_nGoal = rand();
}

void CEasy::EasyCompare(int nGoal, int nInsert)
{
	int nAB, nA, nB;
	char szBuff[10];
	char buff[50];

	memset(szBuff, 0, sizeof(szBuff));
	memset(buff, 0, sizeof(buff));

	nAB = Compare(nGoal, nInsert);

	nA = nAB/10;
	nB = nAB%10;

	_itoa(nInsert, szBuff, 10);
	if (nInsert < 1000)
	{
		for ( int j = 9 ; j > 0 ; j-- )
		{
			szBuff[j] = szBuff[j - 1];
		}
		szBuff[0] = '0';
	}

	sprintf(szBuff, "%s %d A %d B \r\n", szBuff, nA, nB);
	((CEdit*)GetDlgItem(IDC_ANSWER))->ReplaceSel(szBuff, FALSE);

	if (nAB == 40)
	{
		_itoa(nInsert, szBuff, 10);
		if (nInsert < 1000)
		{
			for ( int j = 9 ; j > 0 ; j-- )
			{
				szBuff[j] = szBuff[j - 1];
			}
			szBuff[0] = '0';
		}

		sprintf(buff, "Congratulation! The answer is %s!", szBuff);
		AfxMessageBox(buff);
		if ( AfxMessageBox("Do you want to continute?", MB_YESNO) == IDYES )
		{
			SendMessage(WM_COMMAND, IDC_RESET);
		}
	}
}
